//=========================================================
//Description : USB Seriel product demo program for VC
//DLL Version : USBDII.dll V 2.0.1.9
//Release Date : 2016/12/08
//Author : Samuel Tseng
//
//Copyright 2016 Decision Computer
//All Right Reserved
//=========================================================

// FunctionTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FunctionTest.h"
#include "FunctionTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "USBDII.h"

enum {	USB_16PIO  = 0x01,
		USB_LABKIT = 0x02,
		USB_16PR   = 0x03,
		USB_STARTER= 0x04,
		USB_14ADDA = 0x05,
		USB_8PR	   = 0x06,
		USB_4PR	   = 0x07,
		USB_8PI	   = 0x08,
		USB_8RO	   = 0x09,
		USB_16PI   = 0x0A,
		USB_16RO   = 0x0B,
		USB_32PI   = 0x0C,
		USB_32RO   = 0x0D,
		USB_Industrial = 0x0E,
		mini_USB_4PR = 0x10
};
 
/////////////////////////////////////////////////////////////////////////////
// CFunctionTestDlg dialog

CFunctionTestDlg::CFunctionTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunctionTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunctionTestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunctionTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunctionTestDlg)
	DDX_Control(pDX, IDC_COMBO3, m_cbCOM);
	DDX_Control(pDX, IDC_BUTTON8, m_bnReadJP);
	DDX_Control(pDX, IDC_BUTTON7, m_bnReadAD);
	DDX_Control(pDX, IDC_BUTTON6, m_bnClose);
	DDX_Control(pDX, IDC_BUTTON5, m_bnWrite2);
	DDX_Control(pDX, IDC_BUTTON4, m_bnWrite1);
	DDX_Control(pDX, IDC_BUTTON3, m_bnRead2);
	DDX_Control(pDX, IDC_BUTTON2, m_bnRead1);
	DDX_Control(pDX, IDC_BUTTON1, m_bnOpen);
	DDX_Control(pDX, IDC_EDIT1, m_tbState);
	DDX_Control(pDX, IDC_COMBO2, m_cbID);
	DDX_Control(pDX, IDC_COMBO1, m_cbType);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunctionTestDlg, CDialog)
	//{{AFX_MSG_MAP(CFunctionTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnSelchangeCombo3)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunctionTestDlg message handlers

BOOL CFunctionTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	Mode = true;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunctionTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunctionTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CFunctionTestDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
    hDevice = INVALID_HANDLE_VALUE;

    if(Mode) 
		hDevice = hid_OpenDevice(gCardType,gCardID);
	else
		hDevice = com_OpenDevice(gCardType,gCardID,gCardCom);


	if(hDevice == INVALID_HANDLE_VALUE)
	{
		m_tbState.SetWindowText("Fail to get board address\n");
	}
	else
	{
		m_tbState.SetWindowText("Open Success \n");
		if(!Mode) SetTimer(IDC_TIMER1,100,NULL);
	}	

}


void CFunctionTestDlg::OnSelchangeCombo1() 
{
	// TODO: Add your control notification handler code here

	int i;
	UpdateData();

	i = m_cbType.GetCurSel();

	switch(i){
		case (0):{
			gCardType = USB_LABKIT;
			break;
		}
		case (1):{
			gCardType = USB_4PR;
			break;
		}
		case (2):{
			gCardType = USB_8PI;
			break;
		}
		case (3):{
			gCardType = USB_8RO;
			break;
		}
		case (4):{
			gCardType = USB_8PR;
			break;
		}
		case (5):{
			gCardType = USB_16PI;
			break;
		}
		case (6):{
			gCardType = USB_16RO;
			break;
		}
		case (7):{
			gCardType = USB_16PR;
			break;
		}
		case (8):{
			gCardType = USB_16PIO;
			break;
		}
		case (9):{
			gCardType = USB_32PI;
			break;
		}
		case (10):{
			gCardType = USB_32RO;
			break;
		}
		case (11):{
			gCardType = USB_14ADDA;
			break;
		}
		case (12):{
			gCardType = USB_STARTER;
			break;
		}
		case (13) : {
			gCardType = USB_Industrial;
			break;
		}
		case (14) : {
			gCardType = mini_USB_4PR;
			break;
		}
		default:{
			gCardType = -1;
			break;
		}
	}	

}

void CFunctionTestDlg::OnSelchangeCombo2() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	gCardID = m_cbID.GetCurSel();	

/*
	if(gCardType = USB_STARTER) 
	{
		m_cbID.SetCurSel(0);
		gCardID = 0;
	}
*/
}

void CFunctionTestDlg::OnSelchangeCombo3() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	gCardCom = m_cbCOM.GetCurSel()+1;	
}


void CFunctionTestDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	byte read_data;
	CString temp;
    BOOL lResult; 

    if(Mode) 
		lResult = hid_GetDigitalByte(hDevice,0, &read_data);
	else
		lResult = com_GetDigitalByte(hDevice,0, &read_data);

	if(lResult)
	{
	   temp.Format("Port0 = %d",read_data);	

	   m_tbState.SetWindowText(temp);
	}
	else m_tbState.SetWindowText("Read Port0 Error");

}

void CFunctionTestDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	byte read_data;
	CString temp;
    BOOL lResult; 

    if(Mode) 
		lResult = hid_GetDigitalByte(hDevice,1, &read_data);
	else
		lResult = com_GetDigitalByte(hDevice,1, &read_data);

	if(lResult)
	{
	   temp.Format("Port1 = %d",read_data);	

	   m_tbState.SetWindowText(temp);
	}
	else m_tbState.SetWindowText("Read Port1 Error");
}

void CFunctionTestDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	
	byte write_data = 1;
	CString temp;
    BOOL lResult; 

    if(Mode) 
		lResult = hid_SetDigitalByte(hDevice,2, write_data);
	else
		lResult = com_SetDigitalByte(hDevice,2, write_data);

	if(lResult)
	{
	   temp.Format("Port2 = %d",write_data);	

	   m_tbState.SetWindowText(temp);
	}
	else m_tbState.SetWindowText("Write Port2 Error");	

}

void CFunctionTestDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	
	byte write_data = 3;
	CString temp;
    BOOL lResult; 

	if (Mode) {
		lResult = hid_SetDigitalByte(hDevice, 3, write_data);
	}else{
		lResult = com_SetDigitalByte(hDevice, 3, write_data);
	}
	if(lResult)
	{
	   temp.Format("Port3 = %d",write_data);	

	   m_tbState.SetWindowText(temp);
	}
	else m_tbState.SetWindowText("Write Port3 Error");		
}

void CFunctionTestDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here

	if(hDevice != INVALID_HANDLE_VALUE)
	{
		if (Mode)
			hid_CloseDevice(hDevice);
		else
		{	
			com_CloseDevice(hDevice);
			KillTimer(IDC_TIMER1);
		}

		hDevice = INVALID_HANDLE_VALUE;
		m_tbState.SetWindowText("Device Close");		
	}	

}

void CFunctionTestDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here

	ULONG ad_data;
	CString temp;	

	if(gCardType != USB_LABKIT) return;

	if (hid_GetAnalogChannel(hDevice, 0, &ad_data)) 
	{
	   temp.Format("AD#0 = %d",ad_data);	
	   m_tbState.SetWindowText(temp);
	}
	else m_tbState.SetWindowText("Get AD Error");		

}

void CFunctionTestDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	byte inData;
	CString temp1,temp2;	
	BOOL lResult; 
	
	if(gCardType != USB_8PR) return;

    if(Mode) 
		lResult = hid_GetDigitalByte(hDevice,0x10, &inData);
	else
		lResult = com_GetDigitalByte(hDevice,0x10, &inData);

	if(lResult)
	{
	  if((inData & 0x10) == 0 )
	  	  
      temp1 = "JP10 Close, DIO0-7 Input  ";
      
	 else 
    
      temp1 = "JP10 Open, DIO0-7 Output  "; 
    

	 if((inData & 0x20) == 0)
    
       temp2 = "JP11 Close, DIO8-15 Input  ";
      
     else
       temp2 = "JP11 Open, DIO8-15 Output  ";

	 
	 m_tbState.SetWindowText(temp1+temp2);

	}
	else m_tbState.SetWindowText("Get JP State Error");		

}

void CFunctionTestDlg::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	
	Mode = true;

}

void CFunctionTestDlg::OnRadio2() 
{
	// TODO: Add your control notification handler code here

	Mode = false;
	if( gCardType == 0x0E )
	{
		m_tbState.SetWindowText("USB Industrial does not support serial \n");
	}
}



void CFunctionTestDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	byte inData;
	
	com_GetDigitalByte(hDevice,0, &inData);

	CDialog::OnTimer(nIDEvent);

}
